package org.firstinspires.ftc.teamcode.subsystems;

import com.qualcomm.robotcore.eventloop.opmode.OpMode;
import com.qualcomm.robotcore.eventloop.opmode.TeleOp;

@TeleOp(name = "Hook Test", group = "Debug")
public class HookTest extends OpMode {

    private HangMotorSubsystem skyhook;
    private ArmSubsystem arm;
    private WristSubsystem wrist;
    private ClawSubsystem claw;
    private DualMotorSliderSubsystem slides;
    @Override
    public void init() {
        skyhook = new HangMotorSubsystem(hardwareMap);
        arm = new ArmSubsystem(hardwareMap);
        wrist = new WristSubsystem(hardwareMap);
        claw = new ClawSubsystem(hardwareMap);
        slides = new DualMotorSliderSubsystem(hardwareMap);
        claw.init();
        arm.initTeleOp();
        wrist.initTeleOp();
        slides.init();
        claw.thumbUp();
    }

    @Override
    public void loop() {
        telemetry.addData("hook", skyhook.getCurrentPosition());
        telemetry.addData("arm", arm.getState());
        telemetry.addData("wrist", wrist.getState());
        telemetry.addData("slides", slides.getCurrentPosition());
        telemetry.update();
        slides.update();


        if (gamepad1.a) {
            claw.grabBlueberry();
            arm.setPosition(0.15);
            arm.grabBlueberrySkyhook();
            telemetry.update();
            //claw Open small amount
            wrist.grabBlueberrySkyhook();
            //wrist grab in strange way
            telemetry.update();


            }
        if(gamepad1.b) {
            //confirm grab
            claw.closeClaw();

        }

        if (gamepad1.x) {
            //now slap on bar, first wrist, then arm, then claw then driver must drive away
            slides.toFixedPosition(500);
            slides.update();
        }
        if (gamepad1.y) {
            arm.hangBlueberrySkyhook();
            wrist.hangBlueberrySkyhook();
            try {
                Thread.sleep(500);
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
            slides.toFixedPosition(1800);
            slides.update();
        }
        if (gamepad1.right_bumper) {
            claw.openClaw();
        }
        if (gamepad1.dpad_up && claw.getState() == ClawSubsystem.ClawState.OPEN) {
            skyhook.hangRobot();
        }
        if (gamepad1.left_trigger > 0) {
            skyhook.disableMotor();
            skyhook.setPowerReverse(1.0);
        }
        else if(gamepad1.left_trigger == 0){
            skyhook.setPowerReverse(0.0);
        }
        if (gamepad1.right_trigger > 0) {
            skyhook.disableMotor();
            skyhook.setPowerForward(1.0);
        }
        else if(gamepad1.right_trigger == 0){
            skyhook.setPowerForward(0.0);
        }


    }

}
