package org.firstinspires.ftc.teamcode.subsystems;

import static org.firstinspires.ftc.teamcode.PedroConstants.MAX_POWER;

import com.qualcomm.robotcore.eventloop.opmode.OpMode;
import com.qualcomm.robotcore.eventloop.opmode.TeleOp;

import org.firstinspires.ftc.teamcode.subsystems.ArmSubsystem;
import org.firstinspires.ftc.teamcode.subsystems.ClawSubsystem;
import org.firstinspires.ftc.teamcode.subsystems.DualMotorSliderSubsystem;
import org.firstinspires.ftc.teamcode.subsystems.HangMotorSubsystem;
import org.firstinspires.ftc.teamcode.subsystems.WristSubsystem;
@TeleOp(name = "Inspection", group = "Debug")
public class Inspection extends OpMode {
    private DualMotorSliderSubsystem dualSlides;
    private ClawSubsystem claw;
    private WristSubsystem wrist;
    private ArmSubsystem arm;
    private HangMotorSubsystem skyhook;

    @Override
    public void init() {
        dualSlides = new DualMotorSliderSubsystem(hardwareMap);
        claw = new ClawSubsystem(hardwareMap);
        arm = new ArmSubsystem(hardwareMap);
        wrist = new WristSubsystem(hardwareMap);
        skyhook = new HangMotorSubsystem(hardwareMap);
        dualSlides.init();
        claw.init();
        wrist.initTeleOp();
        arm.initTeleOp();
        skyhook.init();
    }

    @Override
    public void loop() {
        telemetry.addData("a: ", "init");
        telemetry.addData("b: ", "armFloor/WristFloor");
        telemetry.addData("y: ", "GrabSkyhook");
        if(gamepad1.a){
            wrist.InitAuto();
            arm.initAuto();
        }
        if(gamepad1.b){
            arm.toFloorPosition();
            wrist.toFloorPositionTeleop();
        }
        if (gamepad1.y) {
            claw.grabBlueberry();
            arm.setPosition(0.15);
            arm.grabBlueberrySkyhook();

            //claw Open small amount
            wrist.grabBlueberrySkyhook();
            //wrist grab in strange way
        }
    }
}
